<?php //Code based on Menu Items Visibility Control by Hassan Derakhshandeh => https://wordpress.org/plugins/menu-items-visibility-control/
function kleor_menu_items_visibility() {
if (!class_exists('Menu_Items_Visibility_Control')) {
class Menu_Items_Visibility_Control {
private static $instance = null;

public static function get_instance() { return (self::$instance == null ? self::$instance = new self : self::$instance); }

private function __construct() {
if (is_admin()) { load_raising_textdomain(); } else { add_filter('wp_get_nav_menu_items', array($this, 'visibility_check'), 10, 3); }
add_action('wp_nav_menu_item_custom_fields', array($this, 'menu_item_custom_fields'));
add_action('wp_update_nav_menu_item', array($this, 'update_option'), 10, 3);
add_action('delete_post', array($this, 'remove_visibility_meta'), 1, 3); }

function menu_item_custom_fields($item_id) {
$value = get_post_meta($item_id, '_menu_item_visibility', true); ?>
<p class="field-visibility description description-wide">
<label for="menu_item_visibility_<?php echo $item_id; ?>"><?php _e('Visibility', 'raising-manager'); ?><br />
<select id="menu_item_visibility_<?php echo $item_id; ?>" name="menu_item_visibility_<?php echo $item_id; ?>">
<?php $options = array('true' => __('All Internet users', 'raising-manager'));
if (function_exists('raising_session')) {
$options = array_merge($options, array(
'raising_session()' => __('Only Internet users logged in as a volunteer', 'raising-manager'),
'!raising_session()' => __('Only Internet users not logged in as a volunteer', 'raising-manager'))); }
$list = ''; foreach ($options as $key => $name) { $list .= '<option value="'.$key.'"'.($value == $key ? ' selected="selected"' : '').'>'.$name.'</option>'; }
echo $list; ?></select></label></p><?php }

function update_option($menu_id, $item_id, $args) {
if (isset($_POST['menu_item_visibility_'.$item_id])) {
$meta_value = get_post_meta($item_id, '_menu_item_visibility', true);
$new_meta_value = stripcslashes($_POST['menu_item_visibility_'.$item_id]);
if ($new_meta_value == '') { delete_post_meta($item_id, '_menu_item_visibility', $meta_value); }
elseif ($new_meta_value !== $meta_value) { update_post_meta($item_id, '_menu_item_visibility', $new_meta_value); } } }

function visibility_check($items, $menu, $args) {
$hidden_items = array();
foreach ($items as $key => $item) {
$item_parent = get_post_meta($item->ID, '_menu_item_menu_item_parent', true);
$code = get_post_meta($item->ID, '_menu_item_visibility', true);
switch ($code) {
case 'raising_session()': case '!raising_session()':
$function = str_replace(array('!', '(', ')'), '', $code);
if (!function_exists($function)) { $visible = true; }
else { $visible = $function(); if (substr($code, 0, 1) == '!') { $visible = !$visible; } }
break;
default: $visible = true; }
if ((!$visible) || (isset($hidden_items[$item_parent]))) { unset($items[$key]); $hidden_items[$item->ID] = true; } }
return $items; }

function remove_visibility_meta($post_id) { if (is_nav_menu_item($post_id)) { delete_post_meta($post_id, '_menu_item_visibility'); } } }
Menu_Items_Visibility_Control::get_instance(); } }

if (!strstr($_SERVER['REQUEST_URI'], '/plugins.php')) { add_action('init', 'kleor_menu_items_visibility'); }