<?php function raising_convert_minutes_to_time($minutes) {
$h = floor($minutes/60);
$m = $minutes - 60*$h;
return (($h < 10 ? '0' : '').$h.':'.($m < 10 ? '0' : '').$m); }


function raising_convert_time_to_minutes($time) {
$d = preg_split('#[^0-9]#', $time, 0, PREG_SPLIT_NO_EMPTY);
for ($i = 0; $i < 2; $i++) { $d[$i] = (int) (isset($d[$i]) ? $d[$i] : 0); }
return (60*$d[0] + $d[1]); }


function raising_date_compare($date1, $date2) {
if ($date1 == $date2) { return 0; }
$dates = array($date1, $date2);
sort($dates);
if ($dates[0] == $date1) { return -1; } else { return 1; } }


function raising_display_date($date, $format = '') {
if (in_array($date, array('0000-00-00', '1000-01-01'))) { $date = ''; }
if ($date != '') {
global $raising_manager_options;
if ($format == '') { $format = $raising_manager_options['date_format']; }
$d = explode('-', $date);
switch ($format) {
case 'DD/MM/YYYY': $date = $d[2].'/'.$date = $d[1].'/'.$date = $d[0]; break;
case 'MM/DD/YYYY': $date = $d[1].'/'.$date = $d[2].'/'.$date = $d[0]; break;
case 'YYYY/DD/MM': $date = $d[0].'/'.$date = $d[2].'/'.$date = $d[1]; break;
default: $date = $d[0].'/'.$date = $d[1].'/'.$date = $d[2]; } }
return $date; }


function raising_get_duration($times) {
$duration = 0;
foreach ($times as $i => $time) {
if (!is_int($time)) { $times[$i] = raising_convert_time_to_minutes($time); }
if ($i%2 == 1) { $duration = $duration + $times[$i] - $times[($i - 1)]; } }
return $duration; }


function raising_get_limits($times) {
$limits = array(480, 750, 1020, 1290);
foreach ($times as $i => $time) {
if (!is_int($time)) { $times[$i] = (raising_convert_time_to_minutes($time))%1440; } }
if ($times[0] < $times[1]) {
$limits = array(0 => $times[0], 3 => $times[1]);
if ($times[0] < 750) {
if ($times[1] < 750) { $limits[1] = $limits[2] = $times[1]; }
elseif ($times[1] < 1020) { $limits[1] = 750; $limits[2] = $times[1]; }
else { $limits[1] = 750; $limits[2] = 1020; } }
elseif ($times[0] < 1020) {
$limits[1] = $times[0];
if ($times[1] < 1020) { $limits[2] = $times[1]; }
else { $limits[2] = 1020; } }
else { $limits[1] = $limits[2] = $times[0]; }
ksort($limits); }
return $limits; }


function raising_get_times_for_day($t) {
for ($i = 1; $i < 3; $i++) { if ($t[$i][1] == $t[($i + 1)][0]) { $t[($i + 1)][0] = $t[$i][1] = ''; } }
$t = array($t[1][0], $t[1][1], $t[2][0], $t[2][1], $t[3][0], $t[3][1]);
$times = array(); for ($i = 0; $i < 6; $i++) { if ($t[$i] != '') { $times[] = $t[$i]; } }
return $times; }


function raising_get_times_for_each_period($times) {
$t = array(1 => array('', ''), 2 => array('', ''), 3 => array('', ''));
$n = count($times);
$m = array(); for ($i = 0; $i < $n; $i++) {
$m[$i] = (is_int($times[$i]) ? $times[$i] : raising_convert_time_to_minutes($times[$i]));
if ($m[$i] < 480) { $m[$i] = 480; $times[$i] = '08:00'; }
elseif ($m[$i] > 1290) { $m[$i] = 1290; $times[$i] = '21:30'; } }
if ($n == 6) { $t = array(1 => array($times[0], $times[1]), 2 => array($times[2], $times[3]), 3 => array($times[4], $times[5])); }
elseif (($n == 2) || ($n == 4)) {
for ($i = 0; $i < 2; $i++) {
if ($m[$i] < (750 + $i)) { $t[1][$i] = $times[$i]; }
elseif ($m[$i] < (1020 + $i)) { $t[2][$i] = $times[$i]; }
elseif ($m[$i] < (1290 + $i)) { $t[3][$i] = $times[$i]; } }
if ($n == 4) {
for ($i = 0; $i < 2; $i++) {
if ($m[($i + 2)] < (1020 + $i)) { $t[2][$i] = $times[($i + 2)]; }
elseif ($m[($i + 2)] < (1290 + $i)) { $t[3][$i] = $times[($i + 2)]; } } }
if (($t[1][0] == '') && ($t[1][1] != '')) { $t[1][0] = '08:00'; }
elseif (($t[1][0] != '') && ($t[1][1] == '')) { $t[1][1] = '12:30'; }
if (($t[2][0] == '') && ($t[2][1] != '')) { $t[2][0] = '12:30'; }
elseif (($t[2][0] != '') && ($t[2][1] == '')) { $t[2][1] = '17:00'; }
if (($t[3][0] == '') && ($t[3][1] != '')) { $t[3][0] = '17:00'; }
elseif (($t[3][0] != '') && ($t[3][1] == '')) { $t[3][1] = '21:30'; }
if ($n == 2) { if (($t[1][1] == '12:30') && ($t[3][0] == '17:00') && ($t[2] == array('', ''))) { $t[2] = array('12:30', '17:00'); } } }
return $t; }


function raising_offered_durations($date, $volunteer) {
$d = array(0, 0, 0, 0);
$raisings = (array) (is_array($volunteer['raisings']) ? $volunteer['raisings'] : unserialize(stripslashes($volunteer['raisings'])));
if ((isset($raisings[$date])) && (isset($raisings[$date]['times']))) {
$times = $raisings[$date]['times'];
if ($times != array('', '')) {
$times = raising_get_times_for_each_period($times);
for ($i = 1; $i <= 3; $i++) { $d[$i] = raising_convert_time_to_minutes($times[$i][1]) - raising_convert_time_to_minutes($times[$i][0]); if ($d[$i] < 60) { $d[$i] = 0; } }
$maximum = intval($volunteer['maximum_duration1'] == 0 ? 1440 : floor(60*$volunteer['maximum_duration1']));
if ($maximum > 540) { $d[0] = min($maximum, ($d[1] + $d[2] + $d[3])); }
elseif ($maximum > 270) { $d[0] = max(($d[1] + $d[3]), min($maximum, ($d[1] + $d[2])), min($maximum, ($d[2] + $d[3]))); }
else { $d[0] = max($d[1], $d[2], $d[3]); } } }
return $d; }


function raising_required_durations($date, $store, $weekday = 8) {
$d = array(0, 0, 0, 0);
$raisings = (array) (is_array($store['raisings']) ? $store['raisings'] : unserialize(stripslashes($store['raisings'])));
if ((isset($raisings[$date])) && (isset($raisings[$date]['times']))) {
$times = $raisings[$date]['times'];
if ((($times[0] == '') || ($times[1] == '')) && ($weekday > 7)) {
$d = preg_split('#[^0-9]#', $date, 0, PREG_SPLIT_NO_EMPTY);
for ($i = 0; $i < 3; $i++) { $d[$i] = (int) (isset($d[$i]) ? $d[$i] : 0); }
if ($d[0] > 999) { $weekday = date('w', mktime(0, 0, 0, $d[1], $d[2], $d[0])); }
if ($weekday == 0) { $weekday = 7; } }
if (($weekday > 0) && ($weekday < 8)) {
if ($times[0] == '') { $times[0] = $store['opening_time'.$weekday]; }
if ($times[1] == '') { $times[1] = $store['closing_time'.$weekday]; } }
if ($times != array('', '')) {
$times = array_merge(array(0 => $times), raising_get_times_for_each_period($times));
for ($i = 0; $i <= 3; $i++) { $times[$i] = array_map('raising_convert_time_to_minutes', $times[$i]); }
if ($times[0][0] < 480) { $times[0][0] = 480; }
if ($times[0][1] > 1290) { $times[0][1] = 1290; }
for ($i = 0; $i <= 3; $i++) { $d[$i] = ($store['minimum_volunteers_number'])*($times[$i][1] - $times[$i][0]); } } }
return $d; }


function raising_weekday_name($date, $format = '') {
$names = array(
0 => __('Sunday', 'raising-manager'),
1 => __('Monday', 'raising-manager'),
2 => __('Tuesday', 'raising-manager'),
3 => __('Wednesday', 'raising-manager'),
4 => __('Thursday', 'raising-manager'),
5 => __('Friday', 'raising-manager'),
6 => __('Saturday', 'raising-manager'),
7 => __('Sunday', 'raising-manager'),
8 => '');
return $names[(isset($names[$date]) ? $date : raising_weekday_number($date, $format))]; }


function raising_weekday_number($date, $format = '') {
if ($format == '') { $format = 'YYYY/MM/DD'; }
$d = preg_split('#[^0-9]#', $date, 0, PREG_SPLIT_NO_EMPTY);
for ($j = 0; $j < 3; $j++) { $d[$j] = (int) (isset($d[$j]) ? $d[$j] : 0); }
if (($d[0] > 0) && ($d[1] > 0) && ($d[2] > 0)) {
switch ($format) {
case 'DD/MM/YYYY': $Y = $d[2]; $M = $d[1]; $D = $d[0]; break;
case 'MM/DD/YYYY': $Y = $d[2]; $M = $d[0]; $D = $d[1]; break;
case 'YYYY/DD/MM': $Y = $d[0]; $M = $d[2]; $D = $d[1]; break;
default: $Y = $d[0]; $M = $d[1]; $D = $d[2]; }
if ($Y > 999) {
$n = date('w', mktime(0, 0, 0, $M, $D, $Y));
if ($n == 0) { $n = 7; } }
else { $n = 8; } }
else { $n = 8; }
return $n; }