<?php
/*
Plugin Name: Raising Manager
Plugin URI: https://www.kleor.com/raising-manager/
Description: Allows you to manage the raisings.
Version: 8.6.7
Author: Kleor
Author URI: https://www.kleor.com
Update URI: https://www.kleor.com
Text Domain: raising-manager
Domain Path: /languages
*/


define('RAISING_MANAGER_PATH', plugin_dir_path(__FILE__));
define('RAISING_MANAGER_URL', plugin_dir_url(__FILE__));
define('RAISING_MANAGER_FOLDER', substr(plugin_basename(__FILE__), 0, -strlen('/raising-manager.php')));
if (!defined('RAISING_MANAGER_CUSTOM_FILES_PATH')) { define('RAISING_MANAGER_CUSTOM_FILES_PATH', substr(RAISING_MANAGER_PATH, 0, -(strlen(RAISING_MANAGER_FOLDER) + 1)).'raising-manager-custom-files/'); }
define('RAISING_MANAGER_CUSTOM_FILES_URL', site_url().'/'.substr(RAISING_MANAGER_CUSTOM_FILES_PATH, strlen(ABSPATH)));
$plugin_data = get_file_data(__FILE__, array('Version' => 'Version'));
define('RAISING_MANAGER_VERSION', $plugin_data['Version']);
if (!defined('COOKIEHASH')) { $siteurl = get_site_option('siteurl'); define('COOKIEHASH', ($siteurl ? md5($siteurl) : '')); }
if (!function_exists('kleor_add_option')) { include_once raising_path('libraries/options-functions.php'); }
if (!defined('HOME_URL')) { define('HOME_URL', home_url()); }
if (!defined('ROOT_URL')) { $url = explode('/', str_replace('//', '||', HOME_URL)); define('ROOT_URL', str_replace('||', '//', $url[0])); }
if (!defined('HOME_PATH')) { $path = substr(HOME_URL, strlen(ROOT_URL)); define('HOME_PATH', ($path == '' ? '/' : $path)); }
if (!defined('UTC_OFFSET')) { define('UTC_OFFSET', kleor_get_option('gmt_offset')); }

function raising_path($file) { return (file_exists(RAISING_MANAGER_CUSTOM_FILES_PATH.$file) ? RAISING_MANAGER_CUSTOM_FILES_PATH : RAISING_MANAGER_PATH).$file; }

function raising_url($file) { return (file_exists(RAISING_MANAGER_CUSTOM_FILES_PATH.$file) ? RAISING_MANAGER_CUSTOM_FILES_URL : RAISING_MANAGER_URL).$file; }

if (!function_exists('kleor_fix_url')) { include_once raising_path('libraries/formatting-functions.php'); }
if (!function_exists('kleor_do_shortcode')) { include_once raising_path('libraries/shortcodes-functions.php'); }
if (!function_exists('raising_convert_minutes_to_time')) { include_once raising_path('libraries/times-functions.php'); }
if (is_admin()) { include_once raising_path('admin.php'); }

function install_raising_manager($context = '') { include raising_path('includes/install.php'); }

function activate_raising_manager() { install_raising_manager('activation'); }

register_activation_hook(__FILE__, 'activate_raising_manager');

global $wpdb;
$raising_manager_options = (array) kleor_get_option('raising_manager');

if (!wp_doing_ajax()) {
kleor_fix_url();
@session_start(); session_write_close();
if (raising_session()) {
date_default_timezone_set('UTC');
if ((!isset($_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']])) || (!isset($_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']][HOME_PATH]))
 || (raising_data('volunteer_automatically_logged_out') == 'no') || ((time() - $_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']][HOME_PATH]) < 60*raising_data('automatic_logout_delay'))) {
@session_start();
if (isset($_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']])) { $_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] = time(); } else { $_SESSION['raising_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']] = array(HOME_PATH => time()); }
if ((!isset($GLOBALS['volunteer_data'])) || (!isset($GLOBALS['volunteer_data']['login'])) || ($GLOBALS['volunteer_data']['login'] != $_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) {
$GLOBALS['volunteer_data'] = (array) $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."raising_manager_volunteers WHERE login = '".$_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH]."'", OBJECT); }
if ((!isset($GLOBALS['volunteer_data']['status'])) || ($GLOBALS['volunteer_data']['status'] != 'active')) {
if (isset($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) { unset($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH]); }
if (isset($_COOKIE['raising_login_'.COOKIEHASH])) { setcookie('raising_login_'.COOKIEHASH, '', time() - 86400, HOME_PATH); } }
session_write_close(); }
else {
raising_logout();
if (raising_data('volunteer_redirected_after_automatic_logout') == 'yes') {
$url = raising_data('automatic_logout_redirection_url');
if ($url == '') { $url = '../'; }
$strings = explode('#', $url);
$url = $strings[0].(strstr($strings[0], '?') ? '&' : '?').'referring_url='.urlencode($_SERVER['REQUEST_URI']);
if (isset($strings[1])) { $url .= '#'.$strings[1]; }
$url = str_replace(array("'", '"', ';'), '', $url);
if (!headers_sent()) { header('Location: '.$url); exit(); }
else { add_action((is_admin() ? 'admin' : 'wp').'_head', function() use($url) { echo '<script>window.location = "'.$url.'";</script>'; }); } } } }
if (!is_admin()) {
@session_start();
$key = 'personal_informations_'.$_SERVER['REMOTE_ADDR'];
$_SESSION[$key] = (array) (isset($_SESSION[$key]) ? $_SESSION[$key] : array());
include raising_path('libraries/personal-informations.php');
foreach ($personal_informations as $field) {
if (isset($_GET[$field])) { $_SESSION[$key][$field] = $_GET[$field]; }
elseif (isset($_GET[str_replace('_', '-', $field)])) { $_SESSION[$key][$field] = $_GET[str_replace('_', '-', $field)]; } }
if ((isset($_SERVER['HTTP_CF_IPCOUNTRY'])) && (!isset($_SESSION[$key]['country_code']))) {
$_SESSION[$key]['country_code'] = substr(preg_replace('/[^A-Z]/', '', strtoupper($_SERVER['HTTP_CF_IPCOUNTRY'])), 0, 2); }
session_write_close(); } }


function add_volunteer($volunteer) { include raising_path('includes/add-volunteer.php'); }


function load_raising_textdomain($domain = '') {
$domain = 'raising-manager'.($domain == '' ? '' : '-'.$domain);
$file = $domain.'-'.apply_filters('plugin_locale', get_locale(), $domain).'.mo';
if (load_textdomain($domain, raising_path('languages/'.$file))) { return true; }
else { return load_textdomain($domain, WP_LANG_DIR.'/plugins/'.$file); } }


function raising_autoresponders() { include raising_path('includes/autoresponders.php'); return $autoresponders; }


function raising_sort_array_by_keys($array) {
$formatted_keys = array(); foreach ($array as $key => $value) { $formatted_keys[$key] = kleor_format_nice_name($key); }
asort($formatted_keys);
$sorted_array = array(); foreach ($formatted_keys as $key => $value) { $sorted_array[$key] = $array[$key]; }
return $sorted_array; }

add_filter('raising_autoresponders', 'raising_sort_array_by_keys', 100);


function raising_comments_array() { return array(); }

function raising_comments_open() { return false; }

function raising_post_comments() {
global $post;
foreach (array('comments_array', 'comments_open') as $function) { remove_filter($function, 'raising_'.$function); }
if ((isset($post)) && (is_object($post)) && (isset($post->ID))) { kleor_do_shortcode(get_post_meta($post->ID, 'raising', true)); } }

add_filter('the_post', 'raising_post_comments', 1, 0);


function raising_cron() { include raising_path('includes/cron.php'); }

if ((!defined('KLEOR_DEMO')) || (KLEOR_DEMO == false)) { add_action('init', 'raising_cron'); }


function raisings_dates($time = 'all', $id = 0) {
global $wpdb;
$dates = (array) kleor_get_option('raising_manager_raisings_dates');
$id = (int) $id; if ($id > 0) {
$items = $wpdb->get_results("SELECT raising_date FROM ".$wpdb->prefix."raising_manager_plannings WHERE store_id = ".$id, OBJECT);
foreach ($items as $item) { $dates[] = $item->raising_date; } }
$dates = array_unique($dates);
sort($dates);
if ($time != 'all') {
date_default_timezone_set('UTC');
$current_date = date('Y-m-d', time() + 3600*UTC_OFFSET);
$future_dates = array(); $past_dates = array();
foreach ($dates as $date) { if (raising_date_compare($date, $current_date) == 1) { $future_dates[] = $date; } else { $past_dates[] = $date; } }
$dates = ($time == 'future' ? $future_dates : $past_dates); }
return $dates; }


function raising_data($atts) { include raising_path('includes/data.php'); return $data; }


function raising_decimals_data($decimals, $data) { include raising_path('includes/decimals-data.php'); return $data; }


function raising_decrypt_url($url) { $action = 'decrypt'; include raising_path('includes/crypt-url.php'); return $url; }


function raising_encrypt_url($url) { $action = 'encrypt'; include raising_path('includes/crypt-url.php'); return $url; }


function raising_excerpt($data, $length = 80) {
$data = html_entity_decode((string) $data);
if (strlen($data) > $length) { $data = substr($data, 0, ($length - 4)).' […]'; }
return $data; }


function raising_extract_style_tag($content) {
if ((!strstr($content, '<style')) || (!strstr($content, '</style>'))) { $style = ''; }
else {
$array = explode('<style', $content);
$string = $array[0];
$array = explode('</style>', $array[1]);
$style =  '<style'.$array[0].'</style>';
$content =  $string.$array[1]; }
return array($style, $content); }


function raising_filter_data($filter, $data) { include raising_path('includes/filter-data.php'); return $data; }


function raising_format_data($field, $data) { include raising_path('includes/format-data.php'); return $data; }


function raising_hash($string) { include raising_path('includes/hash.php'); return $hash; }


function raising_i18n($string) { load_raising_textdomain(); return __(__($string), 'raising-manager'); }


function raising_init_instructions() {
if ((!defined('POST_ID')) && (!defined('POST_TYPE'))) {
if (isset($_GET['page_id'])) { $id = (int) $_GET['page_id']; if ($id > 0) { define('POST_TYPE', 'page'); } }
else {
$path = explode('?', strtolower($_SERVER['REQUEST_URI']));
$path = explode('#', $path[0]);
$path = str_ireplace(HOME_URL, '', ROOT_URL.$path[0]);
while (substr($path, 0, 1) == '/') { $path = substr($path, 1); }
while (substr($path, -1) == '/') { $path = substr($path, 0, -1); }
if ($path == '') {
$id = (int) (kleor_get_option('show_on_front') == 'page' ? kleor_get_option('page_on_front') : 0);
if ($id > 0) { define('POST_TYPE', 'page'); } }
else {
$id = (int) url_to_postid(ROOT_URL.$_SERVER['REQUEST_URI']);
$GLOBALS['post_data'] = (array) get_post($id);
if (isset($GLOBALS['post_data']['post_type'])) { define('POST_TYPE', $GLOBALS['post_data']['post_type']); } } }
define('POST_ID', $id); }
if ((POST_ID > 0) && (defined('POST_TYPE')) && (POST_TYPE == 'page')) {
add_shortcode('raising-redirection', function($atts) { include_once raising_path("shortcodes.php"); return raising_redirection($atts); });
kleor_do_shortcode(get_post_meta(POST_ID, 'raising', true));
remove_shortcode('raising-redirection'); }
if ((isset($_GET['plugin'])) && ($_GET['plugin'] == 'raising-manager') && (isset($_GET['action'])) && ($_GET['action'] == 'preview')) { include raising_path('includes/preview.php'); } }

add_action('init', 'raising_init_instructions', 1, 0);


function raising_user_data($atts) { include raising_path('includes/user-data.php'); return $data; }


function raising_item_data($type, $atts) { include raising_path('includes/item-data.php'); return $data; }


function raising_planning_data($atts) { return raising_item_data('planning', $atts); }


function raising_store_data($atts) { return raising_item_data('store', $atts); }


function volunteer_data($atts) { return raising_item_data('volunteer', $atts); }


function raising_login_through_wordpress() {
global $user_email, $wpdb;
if ((!raising_session()) && ((!isset($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) || ($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] != 'NONE')) && (is_user_logged_in()) && (!current_user_can('edit_pages')) && (!current_user_can('manage_options'))) {
$result = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."raising_manager_volunteers WHERE email_address = '".$user_email."' AND status = 'active'", OBJECT);
if ($result) { $GLOBALS['volunteer_data'] = (array) $result; @session_start(); $_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] = $result->login; session_write_close(); }
else { @session_start(); $_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] = 'NONE'; session_write_close(); } }
elseif ((!headers_sent()) && (!is_user_logged_in()) && ((!isset($_SESSION['wordpress_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) || ($_SESSION['wordpress_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] != 'NONE')) && (raising_session())) {
$result = $wpdb->get_row("SELECT * FROM ".$wpdb->users." WHERE user_email = '".volunteer_data('email_address')."'", OBJECT);
if (($result) && (!user_can($result->ID, 'edit_pages')) && (!user_can($result->ID, 'manage_options'))) {
$GLOBALS['user_data'] = (array) $result;
wp_set_current_user($result->ID, $result->user_login);
wp_set_auth_cookie($result->ID);
do_action('wp_login', $result->user_login, $result); }
else { @session_start(); $_SESSION['wordpress_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] = 'NONE'; session_write_close(); } } }

if (!wp_doing_ajax()) { add_action('plugins_loaded', 'raising_login_through_wordpress', 1, 0); }


function raising_logout_through_wordpress() {
foreach (array('raising') as $prefix) {
foreach (array('_login', '_login_'.$_SERVER['REMOTE_ADDR'], '_previous_activity_timestamp', '_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']) as $string) {
if (isset($_SESSION[$prefix.$string][HOME_PATH])) { @session_start(); unset($_SESSION[$prefix.$string][HOME_PATH]); session_write_close(); }
if ($string == '_login') { setcookie($prefix.$string.'_'.COOKIEHASH, '', time() - 86400, HOME_PATH); } } } }

if (!wp_doing_ajax()) { add_action('wp_logout', 'raising_logout_through_wordpress', 10, 0); }


function raising_logout() { include raising_path('includes/logout.php'); }


function raising_mail($sender, $receiver, $subject, $body, $attachments = array()) { include raising_path('includes/mail.php'); }


function raising_mysqli_connect() { include raising_path('includes/mysqli-connect.php'); return $link; }


function raising_pages_menu_css() {
global $post;
if (((isset($post)) && (is_object($post)) && (isset($post->post_content)) && (strstr($post->post_content, '[raising-pages-menu')))
 || ((isset($GLOBALS['action'])) && ($GLOBALS['action'] == 'raising_preview') && (isset($_GET['field'])) && ($_GET['field'] == 'pages_menu_code'))) {
$array = raising_extract_style_tag((((isset($GLOBALS['action'])) && ($GLOBALS['action'] == 'raising_preview')) ? $_SESSION['raising_preview_variables']['pages_menu_code'] : kleor_get_option('raising_manager_pages_menu_code')));
echo kleor_do_shortcode($array[0]); } }

add_action('wp_head', 'raising_pages_menu_css');


function raising_session() {
if (wp_doing_ajax()) { return false; }
else {
global $wpdb;
foreach (array('raising', 'wordpress') as $prefix) {
foreach (array('_login', '_login_'.$_SERVER['REMOTE_ADDR'], '_previous_activity_timestamp', '_previous_activity_timestamp_'.$_SERVER['REMOTE_ADDR']) as $string) {
if ((isset($_SESSION[$prefix.$string])) && (!is_array($_SESSION[$prefix.$string]))) { @session_start(); unset($_SESSION[$prefix.$string]); session_write_close(); } } }
if ((isset($_COOKIE['raising_login_'.COOKIEHASH])) && ((!isset($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) || ($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] == 'NONE'))) {
$_COOKIE['raising_login_'.COOKIEHASH] = preg_replace('/[^a-z0-9_@.-]/', '', $_COOKIE['raising_login_'.COOKIEHASH]);
$login = substr($_COOKIE['raising_login_'.COOKIEHASH], 0, -128);
if (substr($_COOKIE['raising_login_'.COOKIEHASH], -128, -64) == raising_hash($login.AUTH_KEY)) {
$result = $wpdb->get_row("SELECT * FROM ".$wpdb->prefix."raising_manager_volunteers WHERE login = '".$login."' AND status = 'active'", OBJECT);
if (($result) && (substr($_COOKIE['raising_login_'.COOKIEHASH], -64) == raising_hash($login.$result->password))) {
$GLOBALS['volunteer_data'] = (array) $result; @session_start(); $_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] = $login; session_write_close(); }
else { setcookie('raising_login_'.COOKIEHASH, '', time() - 86400, HOME_PATH); } } }	
if ((isset($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH])) && ($_SESSION['raising_login_'.$_SERVER['REMOTE_ADDR']][HOME_PATH] != 'NONE')) { return true; } else { return false; } } }


function raising_sql_array($table, $array) { include raising_path('includes/sql-array.php'); return $sql; }


function update_volunteer_custom_fields($id, $custom_fields, $context = '') { include raising_path('includes/update-volunteer-custom-fields.php'); }


function upgrade_raising_manager($version = '', $download_url = '') { include raising_path('includes/upgrade.php'); return $success; }


function raising_manager_plugin_info($res, $action, $args) {
if (($action == 'plugin_information') && ($args->slug == 'raising-manager')) {
$admin_notices = (array) kleor_get_option('raising_manager_admin_notices');
$data = (array) (isset($admin_notices['raising-manager-data']) ? $admin_notices['raising-manager-data'] : array());
if (!empty($data['version'])) {
$res = new stdClass();
foreach ($data as $key => $value) { $res->$key = $value; }
if (!empty($data['download_url'])) { $res->download_link = $data['download_url']; $res->trunk = $data['download_url']; } } }
return $res; }

add_filter('plugins_api', 'raising_manager_plugin_info', 20, 3);


function raising_manager_push_update($transient) {
if (!empty($transient->checked)) {
$admin_notices = (array) kleor_get_option('raising_manager_admin_notices');
$data = (array) (isset($admin_notices['raising-manager-data']) ? $admin_notices['raising-manager-data'] : array());
if ((!empty($data['version'])) && (version_compare(RAISING_MANAGER_VERSION, $data['version'], '<'))) {
$res = new stdClass();
foreach ($data as $key => $value) { $res->$key = $value; }
$res->plugin = 'raising-manager/raising-manager.php';
$res->new_version = $data['version'];
if (!empty($data['download_url'])) { $res->package = $data['download_url']; }
if (!empty($data['notice'])) { add_action('in_plugin_update_message-'.$res->plugin, function() use($data) {
if (!isset($GLOBALS['raising_manager_update_message'])) { $GLOBALS['raising_manager_update_message'] = 'yes'; echo $data['notice']; } }); }
$transient->response[$res->plugin] = $res; } }
return $transient; }

add_filter('site_transient_update_plugins', 'raising_manager_push_update');


class Raising_Meta_Widget extends WP_Widget {
function __construct() {
parent::__construct('raising-meta-widget', __('Meta (Raisings)', 'raising-manager'), array('description' => __('Login/Logout', 'raising-manager'))); }

public function widget($args, $instance) {
extract($args);
$meta_widget = (array) kleor_get_option('raising_manager_meta_widget');
foreach ($instance as $key => $value) { if (($value == '') && (isset($meta_widget[$key]))) { $instance[$key] = $meta_widget[$key]; } }
$title = apply_filters('widget_title', $instance['title']);
$content = apply_filters('widget_text', $instance['content']);
echo $before_widget.$before_title.$title.$after_title.$content.$after_widget; }

public function form($instance) {
$meta_widget = (array) kleor_get_option('raising_manager_meta_widget');
$instance = wp_parse_args($instance, $meta_widget);
$title = esc_attr($instance['title']);
$content = esc_attr($instance['content']); ?>
<p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'raising-manager'); ?>
<input class="widefat" id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>" type="text" value="<?php echo $title; ?>" />
</label></p>
<p><label for="<?php echo $this->get_field_id('content'); ?>"><?php _e('Content:', 'raising-manager'); ?>
<textarea class="widefat" id="<?php echo $this->get_field_id('content'); ?>" name="<?php echo $this->get_field_name('content'); ?>" cols="20" rows="10"><?php echo $content; ?></textarea>
</label></p><?php }

public function update($instance, $old_instance) {
$meta_widget = (array) kleor_get_option('raising_manager_meta_widget');
foreach ($instance as $key => $value) { if (($value == '') && (isset($meta_widget[$key]))) { $instance[$key] = $meta_widget[$key]; } }
return $instance; } }

add_action('widgets_init', function() { return register_widget("Raising_Meta_Widget"); });


if (!function_exists('kleor_menu_items_visibility')) { include_once raising_path('libraries/menu-items-visibility.php'); }


$tags = array('raising-redirection');
foreach (array('raising-content', 'raising-counter') as $tag) {
$function = function($atts, $content) use($tag) { include_once raising_path("shortcodes.php"); $function2 = str_replace('-', '_', $tag); return @$function2($atts, $content); };
for ($i = 0; $i < 4; $i++) { $tags[] = $tag.($i == 0 ? '' : $i); add_shortcode($tag.($i == 0 ? '' : $i), $function); } }

foreach (array(
'' => array(),
'login-' => array('type' => 'login'),
'login-compact-' => array('size' => 'compact', 'type' => 'login'),
'login-widget-' => array('size' => 'compact', 'type' => 'login'),
'password-reset-' => array('type' => 'password_reset'),
'profile-' => array('type' => 'profile'),
'profile-edit-' => array('type' => 'profile'),
'registration-' => array('type' => 'registration'),
'registration-compact-' => array('size' => 'compact', 'type' => 'registration'),
'stores-' => array('type' => 'stores'),
'times-' => array('type' => 'times')) as $key => $value) {
$tag = 'raising-'.$key.'form'; $tags[] = $tag; add_shortcode($tag, function($atts) use($value) { $atts = array_merge((array) $atts, (array) $value); include_once raising_path("forms.php"); return raising_form($atts); }); }

foreach (array(
'' => array(),
'future-' => array('type' => 'future'),
'past-' => array('type' => 'past')) as $key => $value) {
$tag = 'raising-'.$key.'plannings'; $tags[] = $tag; add_shortcode($tag, function($atts) use($value) { $atts = array_merge((array) $atts, (array) $value); include_once raising_path("plannings.php"); return raising_plannings($atts); }); }

foreach (array(
'planning-url',
'volunteer-data-download-link',
'volunteer-data-download-url',
'raising-activation-url',
'raising-comments',
'raising-login-url',
'raising-pages-menu',
'referent-planning-url') as $tag) {
$tags[] = $tag; add_shortcode($tag, function($atts) use($tag) { include_once raising_path("shortcodes.php"); $function2 = str_replace('-', '_', $tag); return @$function2($atts); }); }

$tags[] = 'user'; add_shortcode('user', 'raising_user_data');
$tags[] = 'raising-manager'; add_shortcode('raising-manager', 'raising_data');
$tags[] = 'raising-user'; add_shortcode('raising-user', 'volunteer_data');
foreach (array(
'planning',
'store',
'volunteer') as $tag) { $tags[] = $tag; add_shortcode($tag, ($tag == 'volunteer' ? '' : 'raising_').str_replace('-', '_', $tag).'_data'); }
$raising_manager_shortcodes = $tags;


function replace_raising_manager_shortcodes($data) { include raising_path('includes/replace-shortcodes.php'); return $data; }

add_filter('wp_insert_post_data', 'replace_raising_manager_shortcodes', 10, 1);


foreach (array(
'get_the_excerpt',
'get_the_title',
'single_post_title',
'the_excerpt',
'the_excerpt_rss',
'the_title',
'the_title_attribute',
'the_title_rss',
'widget_text',
'widget_title') as $function) { add_filter($function, 'do_shortcode'); }