/*
 * Date prototype extensions. Doesn't depend on any
 * other code. Doens't overwrite existing methods.
 *
 * Adds dayNames, abbrDayNames, monthNames and abbrMonthNames static properties and isLeapYear,
 * isWeekend, isWeekDay, getDaysInMonth, getDayName, getMonthName, getDayOfYear, getWeekOfYear,
 * setDayOfYear, addYears, addMonths, addDays, addHours, addMinutes, addSeconds methods
 *
 * Copyright (c) 2006 Jrn Zaefferer and Brandon Aaron (brandon.aaron@gmail.com || http://brandonaaron.net)
 *
 * Additional methods and properties added by Kelvin Luck: firstDayOfWeek, dateFormat, zeroTime, asString, fromString -
 * I've added my name to these methods so you know who to blame if they are broken!
 * 
 * Dual licensed under the MIT and GPL licenses:
 *   http://www.opensource.org/licenses/mit-license.php
 *   http://www.gnu.org/licenses/gpl.html
 */
Date.firstDayOfWeek=1;Date.format="yyyy-mm-dd";Date.fullYearStart="20";(function(){function e(e,t){if(!Date.prototype[e]){Date.prototype[e]=t}}e("isLeapYear",function(){var e=this.getFullYear();return e%4==0&&e%100!=0||e%400==0});e("isWeekend",function(){return this.getDay()==0||this.getDay()==6});e("isWeekDay",function(){return!this.isWeekend()});e("getDaysInMonth",function(){return[31,this.isLeapYear()?29:28,31,30,31,30,31,31,30,31,30,31][this.getMonth()]});e("getDayName",function(e){return e?Date.abbrDayNames[this.getDay()]:Date.dayNames[this.getDay()]});e("getMonthName",function(e){return e?Date.abbrMonthNames[this.getMonth()]:Date.monthNames[this.getMonth()]});e("getDayOfYear",function(){var e=new Date("1/1/"+this.getFullYear());return Math.floor((this.getTime()-e.getTime())/864e5)});e("getWeekOfYear",function(){return Math.ceil(this.getDayOfYear()/7)});e("setDayOfYear",function(e){this.setMonth(0);this.setDate(e);return this});e("addYears",function(e){this.setFullYear(this.getFullYear()+e);return this});e("addMonths",function(e){var t=this.getDate();this.setMonth(this.getMonth()+e);if(t>this.getDate())this.addDays(-this.getDate());return this});e("addDays",function(e){this.setTime(this.getTime()+e*864e5);return this});e("addHours",function(e){this.setHours(this.getHours()+e);return this});e("addMinutes",function(e){this.setMinutes(this.getMinutes()+e);return this});e("addSeconds",function(e){this.setSeconds(this.getSeconds()+e);return this});e("zeroTime",function(){this.setMilliseconds(0);this.setSeconds(0);this.setMinutes(0);this.setHours(0);return this});e("asString",function(e){var n=e||Date.format;if(n.split("mm").length>1){n=n.split("mmmm").join(this.getMonthName(false)).split("mmm").join(this.getMonthName(true)).split("mm").join(t(this.getMonth()+1))}else{n=n.split("m").join(this.getMonth()+1)}n=n.split("yyyy").join(this.getFullYear()).split("yy").join((this.getFullYear()+"").substring(2)).split("dd").join(t(this.getDate())).split("d").join(this.getDate());return n});Date.fromString=function(e){var t=Date.format;var n=new Date("01/01/1970");if(e=="")return n;e=e.toLowerCase();var r="";var i=[];var s=/(dd?d?|mm?m?|yy?yy?)+([^(m|d|y)])?/g;var o;while((o=s.exec(t))!=null){switch(o[1]){case"d":case"dd":case"m":case"mm":case"yy":case"yyyy":r+="(\\d+\\d?\\d?\\d?)+";i.push(o[1].substr(0,1));break;case"mmm":r+="([a-z]{3})";i.push("M");break}if(o[2]){r+=o[2]}}var u=new RegExp(r);var a=e.match(u);for(var f=0;f<i.length;f++){var l=a[f+1];switch(i[f]){case"d":n.setDate(l);break;case"m":n.setMonth(Number(l)-1);break;case"M":for(var c=0;c<Date.abbrMonthNames.length;c++){if(Date.abbrMonthNames[c].toLowerCase()==l)break}n.setMonth(c);break;case"y":n.setYear(l);break}}return n};var t=function(e){var t="0"+e;return t.substring(t.length-2)}})();(function(e){function n(e){this.ele=e;this.displayedMonth=null;this.displayedYear=null;this.startDate=null;this.endDate=null;this.showYearNavigation=null;this.closeOnSelect=null;this.displayClose=null;this.rememberViewedMonth=null;this.selectMultiple=null;this.numSelectable=null;this.numSelected=null;this.verticalPosition=null;this.horizontalPosition=null;this.verticalOffset=null;this.horizontalOffset=null;this.button=null;this.renderCallback=[];this.selectedDates={};this.inline=null;this.context="#dp-popup";this.settings={}}function r(t){if(t._dpId)return e.event._dpCache[t._dpId];return false}e.fn.extend({renderCalendar:function(t){var n=function(e){return document.createElement(e)};t=e.extend({},e.fn.datePicker.defaults,t);if(t.showHeader!=e.dpConst.SHOW_HEADER_NONE){var r=e(n("tr"));for(var i=Date.firstDayOfWeek;i<Date.firstDayOfWeek+7;i++){var s=i%7;var o=Date.dayNames[s];r.append(jQuery(n("th")).attr({scope:"col",abbr:o,title:o,"class":s==0||s==6?"weekend":"weekday"}).html(t.showHeader==e.dpConst.SHOW_HEADER_SHORT?o.substr(0,1):o))}}var u=e(n("table")).attr({cellspacing:2}).addClass("jCalendar").append(t.showHeader!=e.dpConst.SHOW_HEADER_NONE?e(n("thead")).append(r):n("thead"));var a=e(n("tbody"));var f=(new Date).zeroTime();f.setHours(12);var l=t.month==undefined?f.getMonth():t.month;var c=t.year||f.getFullYear();var h=new Date(c,l,1,12,0,0);var p=Date.firstDayOfWeek-h.getDay()+1;if(p>1)p-=7;var d=Math.ceil((-1*p+1+h.getDaysInMonth())/7);h.addDays(p-1);var v=function(n){return function(){if(t.hoverClass){var r=e(this);if(!t.selectWeek){r.addClass(t.hoverClass)}else if(n&&!r.is(".disabled")){r.parent().addClass("activeWeekHover")}}}};var m=function(){if(t.hoverClass){var n=e(this);n.removeClass(t.hoverClass);n.parent().removeClass("activeWeekHover")}};var g=0;while(g++<d){var y=jQuery(n("tr"));var b=t.dpController?h>t.dpController.startDate:false;for(var i=0;i<7;i++){var w=h.getMonth()==l;var E=e(n("td")).text(h.getDate()+"").addClass((w?"current-month ":"other-month ")+(h.isWeekend()?"weekend ":"weekday ")+(w&&h.getTime()==f.getTime()?"today ":"")).data("datePickerDate",h.asString()).hover(v(b),m);y.append(E);if(t.renderCallback){t.renderCallback(E,h,l,c)}h=new Date(h.getFullYear(),h.getMonth(),h.getDate()+1,12,0,0)}a.append(y)}u.append(a);return this.each(function(){e(this).empty().append(u)})},datePicker:function(t){if(!e.event._dpCache)e.event._dpCache=[];t=e.extend({},e.fn.datePicker.defaults,t);return this.each(function(){var r=e(this);var i=true;if(!this._dpId){this._dpId=e.guid++;e.event._dpCache[this._dpId]=new n(this);i=false}if(t.inline){t.createButton=false;t.displayClose=false;t.closeOnSelect=false;r.empty()}var o=e.event._dpCache[this._dpId];o.init(t);if(!i&&t.createButton){o.button=e('<a href="#" class="dp-choose-date" title="'+e.dpText.TEXT_CHOOSE_DATE+'"><img style="height: 1.5em; vertical-align: middle;" alt="'+e.dpText.DATE_PICKER_ALT+'" src="'+e.dpText.DATE_PICKER_URL+'" /></a>').bind("click",function(){r.dpDisplay(this);this.blur();return false});r.after(o.button)}if(!i&&r.is(":text")){r.bind("dateSelected",function(e,t,n){this.value=t.asString()}).bind("change",function(){if(this.value==""){o.clearSelected()}else{var e=Date.fromString(this.value);if(e){o.setSelected(e,true,true)}}});if(t.clickInput){r.bind("click",function(){r.trigger("change");r.dpDisplay()})}var u=Date.fromString(this.value);if(this.value!=""&&u){o.setSelected(u,true,true)}}r.addClass("dp-applied")})},dpSetDisabled:function(e){return t.call(this,"setDisabled",e)},dpSetStartDate:function(e){return t.call(this,"setStartDate",e)},dpSetEndDate:function(e){return t.call(this,"setEndDate",e)},dpGetSelected:function(){var e=r(this[0]);if(e){return e.getSelected()}return null},dpSetSelected:function(e,n,r,i){if(n==undefined)n=true;if(r==undefined)r=true;if(i==undefined)i=true;return t.call(this,"setSelected",Date.fromString(e),n,r,i)},dpSetDisplayedMonth:function(e,n){return t.call(this,"setDisplayedMonth",Number(e),Number(n),true)},dpDisplay:function(e){return t.call(this,"display",e)},dpSetRenderCallback:function(e){return t.call(this,"setRenderCallback",e)},dpSetPosition:function(e,n){return t.call(this,"setPosition",e,n)},dpSetOffset:function(e,n){return t.call(this,"setOffset",e,n)},dpClose:function(){return t.call(this,"_closeCalendar",false,this[0])},_dpDestroy:function(){}});var t=function(e,t,n,i,s){return this.each(function(){var o=r(this);if(o){o[e](t,n,i,s)}})};e.extend(n.prototype,{init:function(e){this.setStartDate(e.startDate);this.setEndDate(e.endDate);this.setDisplayedMonth(Number(e.month),Number(e.year));this.setRenderCallback(e.renderCallback);this.showYearNavigation=e.showYearNavigation;this.closeOnSelect=e.closeOnSelect;this.displayClose=e.displayClose;this.rememberViewedMonth=e.rememberViewedMonth;this.selectMultiple=e.selectMultiple;this.numSelectable=e.selectMultiple?e.numSelectable:1;this.numSelected=0;this.verticalPosition=e.verticalPosition;this.horizontalPosition=e.horizontalPosition;this.hoverClass=e.hoverClass;this.setOffset(e.verticalOffset,e.horizontalOffset);this.inline=e.inline;this.settings=e;if(this.inline){this.context=this.ele;this.display()}},setStartDate:function(e){if(e){this.startDate=Date.fromString(e)}if(!this.startDate){this.startDate=(new Date).zeroTime()}this.setDisplayedMonth(this.displayedMonth,this.displayedYear)},setEndDate:function(e){if(e){this.endDate=Date.fromString(e)}if(!this.endDate){this.endDate=new Date("12/31/2999")}if(this.endDate.getTime()<this.startDate.getTime()){this.endDate=this.startDate}this.setDisplayedMonth(this.displayedMonth,this.displayedYear)},setPosition:function(e,t){this.verticalPosition=e;this.horizontalPosition=t},setOffset:function(e,t){this.verticalOffset=parseInt(e)||0;this.horizontalOffset=parseInt(t)||0},setDisabled:function(t){$e=e(this.ele);$e[t?"addClass":"removeClass"]("dp-disabled");if(this.button){$but=e(this.button);$but[t?"addClass":"removeClass"]("dp-disabled");$but.attr("title",t?"":e.dpText.DATE_PICKER_URL)}if($e.is(":text")){$e.attr("disabled",t?"disabled":"")}},setDisplayedMonth:function(t,n,r){if(this.startDate==undefined||this.endDate==undefined){return}var i=new Date(this.startDate.getTime());i.setDate(1);var s=new Date(this.endDate.getTime());s.setDate(1);var o;if(!t&&!n||isNaN(t)&&isNaN(n)){o=(new Date).zeroTime();o.setDate(1)}else if(isNaN(t)){o=new Date(n,this.displayedMonth,1)}else if(isNaN(n)){o=new Date(this.displayedYear,t,1)}else{o=new Date(n,t,1)}if(o.getTime()<i.getTime()){o=i}else if(o.getTime()>s.getTime()){o=s}var u=this.displayedMonth;var a=this.displayedYear;this.displayedMonth=o.getMonth();this.displayedYear=o.getFullYear();if(r&&(this.displayedMonth!=u||this.displayedYear!=a)){this._rerenderCalendar();e(this.ele).trigger("dpMonthChanged",[this.displayedMonth,this.displayedYear])}},setSelected:function(t,n,r,i){if(t<this.startDate||t>this.endDate){return}var s=this.settings;if(s.selectWeek){t=t.addDays(-(t.getDay()-Date.firstDayOfWeek+7)%7);if(t<this.startDate){return}}if(n==this.isSelected(t)){return}if(this.selectMultiple==false){this.clearSelected()}else if(n&&this.numSelected==this.numSelectable){return}if(r&&(this.displayedMonth!=t.getMonth()||this.displayedYear!=t.getFullYear())){this.setDisplayedMonth(t.getMonth(),t.getFullYear(),true)}this.selectedDates[t.asString()]=n;this.numSelected+=n?1:-1;var o="td."+(t.getMonth()==this.displayedMonth?"current-month":"other-month");var u;e(o,this.context).each(function(){if(e(this).data("datePickerDate")==t.asString()){u=e(this);if(s.selectWeek){u.parent()[n?"addClass":"removeClass"]("selectedWeek")}u[n?"addClass":"removeClass"]("selected")}});e("td",this.context).not(".selected")[this.selectMultiple&&this.numSelected==this.numSelectable?"addClass":"removeClass"]("unselectable");if(i){var s=this.isSelected(t);$e=e(this.ele);var a=Date.fromString(t.asString());$e.trigger("dateSelected",[a,u,s]);$e.trigger("change")}},isSelected:function(e){return this.selectedDates[e.asString()]},getSelected:function(){var e=[];for(s in this.selectedDates){if(this.selectedDates[s]==true){e.push(Date.fromString(s))}}return e},clearSelected:function(){this.selectedDates={};this.numSelected=0;e("td.selected",this.context).removeClass("selected").parent().removeClass("selectedWeek")},display:function(t){if(e(this.ele).is(".dp-disabled"))return;t=t||this.ele;var n=this;var r=e(t);var i=r.offset();var s;var o;var u;var a;if(n.inline){s=e(this.ele);o={id:"calendar-"+this.ele._dpId,"class":"dp-popup dp-popup-inline"};e(".dp-popup",s).remove();a={}}else{s=e("body");o={id:"dp-popup","class":"dp-popup"};a={top:i.top+n.verticalOffset,left:i.left+n.horizontalOffset};var f=function(t){var r=t.target;var i=e("#dp-popup")[0];while(true){if(r==i){return true}else if(r==document){n._closeCalendar();return false}else{r=e(r).parent()[0]}}};this._checkMouse=f;n._closeCalendar(true);e(document).bind("keydown.datepicker",function(e){if(e.keyCode==27){n._closeCalendar()}})}if(!n.rememberViewedMonth){var l=this.getSelected()[0];if(l){l=new Date(l);this.setDisplayedMonth(l.getMonth(),l.getFullYear(),false)}}s.append(e("<div></div>").attr(o).css(a).append(e("<h2></h2>"),e('<div class="dp-nav-prev"></div>').append(e('<a class="dp-nav-prev-year" href="#" title="'+e.dpText.TEXT_PREV_YEAR+'"><<</a>').bind("click",function(){return n._displayNewMonth.call(n,this,0,-1)}),e('<a class="dp-nav-prev-month" href="#" title="'+e.dpText.TEXT_PREV_MONTH+'"><</a>').bind("click",function(){return n._displayNewMonth.call(n,this,-1,0)})),e('<div class="dp-nav-next"></div>').append(e('<a class="dp-nav-next-year" href="#" title="'+e.dpText.TEXT_NEXT_YEAR+'">>></a>').bind("click",function(){return n._displayNewMonth.call(n,this,0,1)}),e('<a class="dp-nav-next-month" href="#" title="'+e.dpText.TEXT_NEXT_MONTH+'">></a>').bind("click",function(){return n._displayNewMonth.call(n,this,1,0)})),e('<div class="dp-calendar"></div>')).bgIframe());var c=this.inline?e(".dp-popup",this.context):e("#dp-popup");if(this.showYearNavigation==false){e(".dp-nav-prev-year, .dp-nav-next-year",n.context).css("display","none")}if(this.displayClose){c.append(e('<a href="#" id="dp-close">'+e.dpText.TEXT_CLOSE+"</a>").bind("click",function(){n._closeCalendar();return false}))}n._renderCalendar();e(this.ele).trigger("dpDisplayed",c);if(!n.inline){if(this.verticalPosition==e.dpConst.POS_BOTTOM){c.css("top",i.top+r.height()-c.height()+n.verticalOffset)}if(this.horizontalPosition==e.dpConst.POS_RIGHT){c.css("left",i.left+r.width()-c.width()+n.horizontalOffset)}e(document).bind("mousedown.datepicker",this._checkMouse)}},setRenderCallback:function(e){if(e==null)return;if(e&&typeof e=="function"){e=[e]}this.renderCallback=this.renderCallback.concat(e)},cellRender:function(t,n,r,i){var s=this.dpController;var o=new Date(n.getTime());t.bind("click",function(){var t=e(this);if(!t.is(".disabled")){s.setSelected(o,!t.is(".selected")||!s.selectMultiple,false,true);if(s.closeOnSelect){s._closeCalendar()}}});if(s.isSelected(o)){t.addClass("selected");if(s.settings.selectWeek){t.parent().addClass("selectedWeek")}}else if(s.selectMultiple&&s.numSelected==s.numSelectable){t.addClass("unselectable")}},_applyRenderCallbacks:function(){var t=this;e("td",this.context).each(function(){for(var n=0;n<t.renderCallback.length;n++){$td=e(this);t.renderCallback[n].apply(this,[$td,Date.fromString($td.data("datePickerDate")),t.displayedMonth,t.displayedYear])}});return},_displayNewMonth:function(t,n,r){if(!e(t).is(".disabled")){this.setDisplayedMonth(this.displayedMonth+n,this.displayedYear+r,true)}t.blur();return false},_rerenderCalendar:function(){this._clearCalendar();this._renderCalendar()},_renderCalendar:function(){e("h2",this.context).html((new Date(this.displayedYear,this.displayedMonth,1)).asString(e.dpText.HEADER_FORMAT));e(".dp-calendar",this.context).renderCalendar(e.extend({},this.settings,{month:this.displayedMonth,year:this.displayedYear,renderCallback:this.cellRender,dpController:this,hoverClass:this.hoverClass}));if(this.displayedYear==this.startDate.getFullYear()&&this.displayedMonth==this.startDate.getMonth()){e(".dp-nav-prev-year",this.context).addClass("disabled");e(".dp-nav-prev-month",this.context).addClass("disabled");e(".dp-calendar td.other-month",this.context).each(function(){var t=e(this);if(Number(t.text())>20){t.addClass("disabled")}});var t=this.startDate.getDate();e(".dp-calendar td.current-month",this.context).each(function(){var n=e(this);if(Number(n.text())<t){n.addClass("disabled")}})}else{e(".dp-nav-prev-year",this.context).removeClass("disabled");e(".dp-nav-prev-month",this.context).removeClass("disabled");var t=this.startDate.getDate();if(t>20){var n=this.startDate.getTime();var r=new Date(n);r.addMonths(1);if(this.displayedYear==r.getFullYear()&&this.displayedMonth==r.getMonth()){e(".dp-calendar td.other-month",this.context).each(function(){var t=e(this);if(Date.fromString(t.data("datePickerDate")).getTime()<n){t.addClass("disabled")}})}}}if(this.displayedYear==this.endDate.getFullYear()&&this.displayedMonth==this.endDate.getMonth()){e(".dp-nav-next-year",this.context).addClass("disabled");e(".dp-nav-next-month",this.context).addClass("disabled");e(".dp-calendar td.other-month",this.context).each(function(){var t=e(this);if(Number(t.text())<14){t.addClass("disabled")}});var t=this.endDate.getDate();e(".dp-calendar td.current-month",this.context).each(function(){var n=e(this);if(Number(n.text())>t){n.addClass("disabled")}})}else{e(".dp-nav-next-year",this.context).removeClass("disabled");e(".dp-nav-next-month",this.context).removeClass("disabled");var t=this.endDate.getDate();if(t<13){var i=new Date(this.endDate.getTime());i.addMonths(-1);if(this.displayedYear==i.getFullYear()&&this.displayedMonth==i.getMonth()){e(".dp-calendar td.other-month",this.context).each(function(){var n=e(this);var r=Number(n.text());if(r<13&&r>t){n.addClass("disabled")}})}}}this._applyRenderCallbacks()},_closeCalendar:function(t,n){if(!n||n==this.ele){e(document).unbind("mousedown.datepicker");e(document).unbind("keydown.datepicker");this._clearCalendar();e("#dp-popup a").unbind();e("#dp-popup").empty().remove();if(!t){e(this.ele).trigger("dpClosed",[this.getSelected()])}}},_clearCalendar:function(){e(".dp-calendar td",this.context).unbind();e(".dp-calendar",this.context).empty()}});e.dpConst={SHOW_HEADER_NONE:0,SHOW_HEADER_SHORT:1,SHOW_HEADER_LONG:2,POS_TOP:0,POS_BOTTOM:1,POS_LEFT:0,POS_RIGHT:1,DP_INTERNAL_FOCUS:"dpInternalFocusTrigger"};e.dpVersion="$Id: jquery.datePicker.js 84 2009-08-05 17:54:35Z kelvin.luck@gmail.com $";e.fn.datePicker.defaults={month:undefined,year:undefined,showHeader:e.dpConst.SHOW_HEADER_SHORT,startDate:undefined,endDate:undefined,inline:false,renderCallback:null,createButton:true,showYearNavigation:true,closeOnSelect:true,displayClose:false,selectMultiple:false,numSelectable:Number.MAX_VALUE,clickInput:false,rememberViewedMonth:true,selectWeek:false,verticalPosition:e.dpConst.POS_TOP,horizontalPosition:e.dpConst.POS_LEFT,verticalOffset:0,horizontalOffset:0,hoverClass:"dp-hover"};if(e.fn.bgIframe==undefined){e.fn.bgIframe=function(){return this}}e(window).bind("unload",function(){var t=e.event._dpCache||[];for(var n in t){e(t[n].ele)._dpDestroy()}})})(jQuery)